Statistics
| Branch: | Tag: | Revision:

root / Makefile.am @ c478f837

History | View | Annotate | Download (30.3 kB)

1 e8230860 Michael Hanselmann
# Ganeti makefile
2 e8230860 Michael Hanselmann
# - Indent with tabs only.
3 e8230860 Michael Hanselmann
# - Keep files sorted; one line per file.
4 e8230860 Michael Hanselmann
# - Directories in lib/ must have their own *dir variable (see hypervisor).
5 e8230860 Michael Hanselmann
# - All directories must be listed DIRS.
6 0a7bed64 Michael Hanselmann
# - Use autogen.sh to generate Makefile.in and configure script.
7 e8230860 Michael Hanselmann
8 e8230860 Michael Hanselmann
# Automake doesn't export these variables before version 1.10.
9 e8230860 Michael Hanselmann
abs_top_builddir = @abs_top_builddir@
10 e8230860 Michael Hanselmann
abs_top_srcdir = @abs_top_srcdir@
11 e8230860 Michael Hanselmann
12 a01dd3c6 Iustin Pop
# Use bash in order to be able to use pipefail
13 a01dd3c6 Iustin Pop
SHELL=/bin/bash
14 a01dd3c6 Iustin Pop
15 6e06b36c Iustin Pop
ACLOCAL_AMFLAGS = -I autotools
16 4f3d5b76 Michael Hanselmann
BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
17 b959138f Michael Hanselmann
RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
18 eed5c5df Michael Hanselmann
CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
19 a4f12da4 Michael Hanselmann
CHECK_MAN = $(top_srcdir)/autotools/check-man
20 96602be4 Michael Hanselmann
CHECK_VERSION = $(top_srcdir)/autotools/check-version
21 7385c51d Michael Hanselmann
CHECK_NEWS = $(top_srcdir)/autotools/check-news
22 95eb4188 Michael Hanselmann
DOCPP = $(top_srcdir)/autotools/docpp
23 e8230860 Michael Hanselmann
REPLACE_VARS_SED = autotools/replace_vars.sed
24 e8230860 Michael Hanselmann
25 22c5390d Iustin Pop
# Note: these are automake-specific variables, and must be named after
26 22c5390d Iustin Pop
# the directory + 'dir' suffix
27 2d48a3a2 Michael Hanselmann
clientdir = $(pkgpythondir)/client
28 e8230860 Michael Hanselmann
hypervisordir = $(pkgpythondir)/hypervisor
29 ff9efc03 Michael Hanselmann
httpdir = $(pkgpythondir)/http
30 dc101ecc Michael Hanselmann
masterddir = $(pkgpythondir)/masterd
31 12426ae1 Guido Trotter
confddir = $(pkgpythondir)/confd
32 8c229cc7 Oleksiy Mishchenko
rapidir = $(pkgpythondir)/rapi
33 899c4d2c Michael Hanselmann
serverdir = $(pkgpythondir)/server
34 9f4bb951 Michael Hanselmann
watcherdir = $(pkgpythondir)/watcher
35 bb44b1ae Michael Hanselmann
impexpddir = $(pkgpythondir)/impexpd
36 c047a981 Michael Hanselmann
utilsdir = $(pkgpythondir)/utils
37 e8230860 Michael Hanselmann
toolsdir = $(pkglibdir)/tools
38 7617fd6b Iustin Pop
iallocatorsdir = $(pkglibdir)/iallocators
39 e8230860 Michael Hanselmann
docdir = $(datadir)/doc/$(PACKAGE)
40 e8230860 Michael Hanselmann
41 a4f12da4 Michael Hanselmann
# Delete output file if an error occurred while building it
42 a4f12da4 Michael Hanselmann
.DELETE_ON_ERROR:
43 a4f12da4 Michael Hanselmann
44 d5506465 Iustin Pop
HTOOLS_DIRS = \
45 d5506465 Iustin Pop
	htools \
46 d5506465 Iustin Pop
	htools/Ganeti \
47 d5506465 Iustin Pop
	htools/Ganeti/HTools
48 d5506465 Iustin Pop
49 e8230860 Michael Hanselmann
DIRS = \
50 e8230860 Michael Hanselmann
	autotools \
51 e8230860 Michael Hanselmann
	daemons \
52 e8230860 Michael Hanselmann
	devel \
53 e8230860 Michael Hanselmann
	doc \
54 e8230860 Michael Hanselmann
	doc/examples \
55 d6d9ce45 Guido Trotter
	doc/examples/hooks \
56 c51580b3 Guido Trotter
	doc/examples/gnt-debug \
57 d5506465 Iustin Pop
	$(HTOOLS_DIRS) \
58 e8230860 Michael Hanselmann
	lib \
59 2d48a3a2 Michael Hanselmann
	lib/client \
60 f9897b6d Michael Hanselmann
	lib/build \
61 2f16ea8f Michael Hanselmann
	lib/confd \
62 ff9efc03 Michael Hanselmann
	lib/http \
63 e8230860 Michael Hanselmann
	lib/hypervisor \
64 bb44b1ae Michael Hanselmann
	lib/impexpd \
65 dc101ecc Michael Hanselmann
	lib/masterd \
66 8c229cc7 Oleksiy Mishchenko
	lib/rapi \
67 899c4d2c Michael Hanselmann
	lib/server \
68 c047a981 Michael Hanselmann
	lib/utils \
69 9f4bb951 Michael Hanselmann
	lib/watcher \
70 e8230860 Michael Hanselmann
	man \
71 e8230860 Michael Hanselmann
	qa \
72 e8230860 Michael Hanselmann
	test \
73 e8230860 Michael Hanselmann
	test/data \
74 e8230860 Michael Hanselmann
	tools
75 e8230860 Michael Hanselmann
76 2750b299 Michael Hanselmann
BUILDTIME_DIR_AUTOCREATE = \
77 c964d962 Michael Hanselmann
	scripts \
78 22c5390d Iustin Pop
	$(APIDOC_DIR) \
79 22c5390d Iustin Pop
	$(APIDOC_PY_DIR) \
80 22c5390d Iustin Pop
	$(APIDOC_HS_DIR) \
81 22c5390d Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
82 22c5390d Iustin Pop
	$(COVERAGE_DIR) \
83 22c5390d Iustin Pop
	$(COVERAGE_PY_DIR) \
84 22c5390d Iustin Pop
	$(COVERAGE_HS_DIR) \
85 b91e9518 Iustin Pop
	.hpc
86 2750b299 Michael Hanselmann
87 2750b299 Michael Hanselmann
BUILDTIME_DIRS = \
88 2750b299 Michael Hanselmann
	$(BUILDTIME_DIR_AUTOCREATE) \
89 6b997854 Michael Hanselmann
	doc/html
90 6b997854 Michael Hanselmann
91 6b997854 Michael Hanselmann
DIRCHECK_EXCLUDE = \
92 6b997854 Michael Hanselmann
	$(BUILDTIME_DIRS) \
93 6b997854 Michael Hanselmann
	ganeti-[0-9]*.[0-9]*.[0-9]* \
94 6b997854 Michael Hanselmann
	doc/html/_*
95 6b997854 Michael Hanselmann
96 2750b299 Michael Hanselmann
all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
97 c964d962 Michael Hanselmann
98 22c5390d Iustin Pop
# some helper vars
99 22c5390d Iustin Pop
COVERAGE_DIR = doc/coverage
100 22c5390d Iustin Pop
COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
101 22c5390d Iustin Pop
COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
102 22c5390d Iustin Pop
APIDOC_DIR = doc/api
103 22c5390d Iustin Pop
APIDOC_PY_DIR = $(APIDOC_DIR)/py
104 22c5390d Iustin Pop
APIDOC_HS_DIR = $(APIDOC_DIR)/hs
105 22c5390d Iustin Pop
106 2ab2b9f5 Iustin Pop
MAINTAINERCLEANFILES = \
107 d17e74b4 Iustin Pop
	$(docpng) \
108 b76aac08 Michael Hanselmann
	$(maninput) \
109 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
110 84a12e40 Iustin Pop
	doc/news.rst \
111 7a03d293 Michael Hanselmann
	doc/upgrade.rst \
112 84a12e40 Iustin Pop
	vcs-version
113 2ab2b9f5 Iustin Pop
114 d17e74b4 Iustin Pop
maintainer-clean-local:
115 6b997854 Michael Hanselmann
	rm -rf $(BUILDTIME_DIRS)
116 d17e74b4 Iustin Pop
117 e8230860 Michael Hanselmann
CLEANFILES = \
118 2f16ea8f Michael Hanselmann
	$(addsuffix /*.py[co],$(DIRS)) \
119 d5506465 Iustin Pop
	$(addsuffix /*.hi,$(HTOOLS_DIRS)) \
120 d5506465 Iustin Pop
	$(addsuffix /*.o,$(HTOOLS_DIRS)) \
121 c964d962 Michael Hanselmann
	$(all_dirfiles) \
122 2d48a3a2 Michael Hanselmann
	$(PYTHON_BOOTSTRAP) \
123 f774bd03 Michael Hanselmann
	epydoc.conf \
124 e8230860 Michael Hanselmann
	autotools/replace_vars.sed \
125 f154a7a3 Michael Hanselmann
	daemons/daemon-util \
126 46a8da3b René Nussbaumer
	daemons/ensure-dirs \
127 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner \
128 e8230860 Michael Hanselmann
	devel/upload \
129 f72f8622 Iustin Pop
	doc/examples/bash_completion \
130 e8230860 Michael Hanselmann
	doc/examples/ganeti.initd \
131 5d9e167a Miguel Di Ciurcio Filho
	doc/examples/ganeti-kvm-poweroff.initd \
132 e8230860 Michael Hanselmann
	doc/examples/ganeti.cron \
133 679008e7 Iustin Pop
	doc/examples/gnt-config-backup \
134 a2442bf9 Luca Bigliardi
	doc/examples/hooks/ipsec \
135 2ab2b9f5 Iustin Pop
	$(man_MANS) \
136 2ab2b9f5 Iustin Pop
	$(manhtml) \
137 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
138 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
139 d6159933 Iustin Pop
	$(nodist_pkgpython_PYTHON) \
140 c3f67183 Iustin Pop
	$(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
141 191ff68c Iustin Pop
	.hpc/*.mix htools/*.tix \
142 191ff68c Iustin Pop
	doc/hs-lint.html
143 e8230860 Michael Hanselmann
144 c964d962 Michael Hanselmann
# BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
145 c964d962 Michael Hanselmann
# it'll cause the target to rebuild every time.
146 dc7d2c49 Michael Hanselmann
BUILT_SOURCES = \
147 dc7d2c49 Michael Hanselmann
	ganeti \
148 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
149 2d1f248e Michael Hanselmann
	lib/_autoconf.py \
150 c964d962 Michael Hanselmann
	$(all_dirfiles) \
151 2d1f248e Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
152 2d1f248e Michael Hanselmann
153 e8230860 Michael Hanselmann
nodist_pkgpython_PYTHON = \
154 e8230860 Michael Hanselmann
	lib/_autoconf.py
155 e8230860 Michael Hanselmann
156 f9897b6d Michael Hanselmann
noinst_PYTHON = \
157 5f43f393 Michael Hanselmann
	lib/build/__init__.py \
158 5f43f393 Michael Hanselmann
	lib/build/sphinx_ext.py
159 f9897b6d Michael Hanselmann
160 e8230860 Michael Hanselmann
pkgpython_PYTHON = \
161 e8230860 Michael Hanselmann
	lib/__init__.py \
162 a8a76bc2 Guido Trotter
	lib/asyncnotifier.py \
163 e8230860 Michael Hanselmann
	lib/backend.py \
164 e8230860 Michael Hanselmann
	lib/bdev.py \
165 e8230860 Michael Hanselmann
	lib/bootstrap.py \
166 e8230860 Michael Hanselmann
	lib/cli.py \
167 e8230860 Michael Hanselmann
	lib/cmdlib.py \
168 cea881e5 Michael Hanselmann
	lib/compat.py \
169 e8230860 Michael Hanselmann
	lib/config.py \
170 e8230860 Michael Hanselmann
	lib/constants.py \
171 821d9e43 Michael Hanselmann
	lib/daemon.py \
172 e8230860 Michael Hanselmann
	lib/errors.py \
173 62e0e880 Iustin Pop
	lib/ht.py \
174 e8230860 Michael Hanselmann
	lib/jqueue.py \
175 8b537bb0 Michael Hanselmann
	lib/jstore.py \
176 e8230860 Michael Hanselmann
	lib/locking.py \
177 e8230860 Michael Hanselmann
	lib/luxi.py \
178 e8230860 Michael Hanselmann
	lib/mcpu.py \
179 a744b676 Manuel Franceschini
	lib/netutils.py \
180 e8230860 Michael Hanselmann
	lib/objects.py \
181 e8230860 Michael Hanselmann
	lib/opcodes.py \
182 a123dc19 Michael Hanselmann
	lib/qlang.py \
183 4ca96421 Michael Hanselmann
	lib/query.py \
184 e8230860 Michael Hanselmann
	lib/rpc.py \
185 f12e1736 René Nussbaumer
	lib/runtime.py \
186 e8230860 Michael Hanselmann
	lib/serializer.py \
187 e8230860 Michael Hanselmann
	lib/ssconf.py \
188 e8230860 Michael Hanselmann
	lib/ssh.py \
189 ac2d0fe4 Michael Hanselmann
	lib/storage.py \
190 1338f2b4 Balazs Lecz
	lib/uidpool.py \
191 76094e37 Michael Hanselmann
	lib/workerpool.py
192 e8230860 Michael Hanselmann
193 2d48a3a2 Michael Hanselmann
client_PYTHON = \
194 c2855a12 Michael Hanselmann
	lib/client/__init__.py \
195 02266fe0 Michael Hanselmann
	lib/client/gnt_backup.py \
196 7b3e7d41 Michael Hanselmann
	lib/client/gnt_cluster.py \
197 6d50f5f9 Michael Hanselmann
	lib/client/gnt_debug.py \
198 667dbd6b Adeodato Simo
	lib/client/gnt_group.py \
199 e792102d Michael Hanselmann
	lib/client/gnt_instance.py \
200 a09b9e3d Michael Hanselmann
	lib/client/gnt_job.py \
201 37494fa4 Michael Hanselmann
	lib/client/gnt_node.py \
202 6d50f5f9 Michael Hanselmann
	lib/client/gnt_os.py
203 2d48a3a2 Michael Hanselmann
204 e8230860 Michael Hanselmann
hypervisor_PYTHON = \
205 e8230860 Michael Hanselmann
	lib/hypervisor/__init__.py \
206 e8230860 Michael Hanselmann
	lib/hypervisor/hv_base.py \
207 48297fa2 Iustin Pop
	lib/hypervisor/hv_chroot.py \
208 e8230860 Michael Hanselmann
	lib/hypervisor/hv_fake.py \
209 eb58f9b1 Guido Trotter
	lib/hypervisor/hv_kvm.py \
210 4b5e40a5 Iustin Pop
	lib/hypervisor/hv_lxc.py \
211 e8230860 Michael Hanselmann
	lib/hypervisor/hv_xen.py
212 e8230860 Michael Hanselmann
213 8c229cc7 Oleksiy Mishchenko
rapi_PYTHON = \
214 8c229cc7 Oleksiy Mishchenko
	lib/rapi/__init__.py \
215 10b207d4 Oleksiy Mishchenko
	lib/rapi/baserlib.py \
216 95ab4de9 David Knowles
	lib/rapi/client.py \
217 20b509de Michael Hanselmann
	lib/rapi/client_utils.py \
218 10b207d4 Oleksiy Mishchenko
	lib/rapi/connector.py \
219 10b207d4 Oleksiy Mishchenko
	lib/rapi/rlib2.py
220 8c229cc7 Oleksiy Mishchenko
221 ff9efc03 Michael Hanselmann
http_PYTHON = \
222 02cab3e7 Michael Hanselmann
	lib/http/__init__.py \
223 be500c29 Michael Hanselmann
	lib/http/auth.py \
224 02cab3e7 Michael Hanselmann
	lib/http/client.py \
225 02cab3e7 Michael Hanselmann
	lib/http/server.py
226 ff9efc03 Michael Hanselmann
227 12426ae1 Guido Trotter
confd_PYTHON = \
228 71f27d19 Guido Trotter
	lib/confd/__init__.py \
229 e4ccf6cd Guido Trotter
	lib/confd/client.py \
230 2f16ea8f Michael Hanselmann
	lib/confd/querylib.py \
231 2f16ea8f Michael Hanselmann
	lib/confd/server.py
232 8c229cc7 Oleksiy Mishchenko
233 dc101ecc Michael Hanselmann
masterd_PYTHON = \
234 033a1d00 Michael Hanselmann
	lib/masterd/__init__.py \
235 033a1d00 Michael Hanselmann
	lib/masterd/instance.py
236 dc101ecc Michael Hanselmann
237 bb44b1ae Michael Hanselmann
impexpd_PYTHON = \
238 bb44b1ae Michael Hanselmann
	lib/impexpd/__init__.py
239 bb44b1ae Michael Hanselmann
240 9f4bb951 Michael Hanselmann
watcher_PYTHON = \
241 9f4bb951 Michael Hanselmann
	lib/watcher/__init__.py
242 9f4bb951 Michael Hanselmann
243 899c4d2c Michael Hanselmann
server_PYTHON = \
244 29d91329 Michael Hanselmann
	lib/server/__init__.py \
245 5c9c0e0e Michael Hanselmann
	lib/server/confd.py \
246 5119f2ec Michael Hanselmann
	lib/server/masterd.py \
247 d9c82a4e Michael Hanselmann
	lib/server/noded.py \
248 d9c82a4e Michael Hanselmann
	lib/server/rapi.py
249 899c4d2c Michael Hanselmann
250 c047a981 Michael Hanselmann
utils_PYTHON = \
251 4fd029cf Michael Hanselmann
	lib/utils/__init__.py \
252 79d22269 Michael Hanselmann
	lib/utils/algo.py \
253 9d1b963f Michael Hanselmann
	lib/utils/filelock.py \
254 f21bb4b7 Michael Hanselmann
	lib/utils/hash.py \
255 3865ca48 Michael Hanselmann
	lib/utils/io.py \
256 1ae4c5a1 Michael Hanselmann
	lib/utils/log.py \
257 36a4acd4 Michael Hanselmann
	lib/utils/mlock.py \
258 17b97ab3 Michael Hanselmann
	lib/utils/nodesetup.py \
259 a4ccecf6 Michael Hanselmann
	lib/utils/process.py \
260 7fcffe27 Michael Hanselmann
	lib/utils/retry.py \
261 7831fc5f Michael Hanselmann
	lib/utils/text.py \
262 c50645c0 Michael Hanselmann
	lib/utils/wrapper.py \
263 c50645c0 Michael Hanselmann
	lib/utils/x509.py
264 c047a981 Michael Hanselmann
265 f05c99f3 Michael Hanselmann
docrst = \
266 ffa6869f Iustin Pop
	doc/admin.rst \
267 5c0c1eeb Iustin Pop
	doc/design-2.0.rst \
268 4f366caf Michael Hanselmann
	doc/design-2.1.rst \
269 e56bb0e8 Guido Trotter
	doc/design-2.2.rst \
270 1eb85930 Guido Trotter
	doc/design-2.3.rst \
271 92902e91 Iustin Pop
	doc/design-htools-2.3.rst \
272 78b40c5e Michael Hanselmann
	doc/design-2.4.rst \
273 c95c0f71 Michael Hanselmann
	doc/design-draft.rst \
274 1e86ee97 Marc Schmitt
	doc/design-oob.rst \
275 e5a246df Michael Hanselmann
	doc/design-query2.rst \
276 539f195a Michael Hanselmann
	doc/design-x509-ca.rst \
277 278ddaa9 Michael Hanselmann
	doc/design-http-server.rst \
278 1375e1d9 Michael Hanselmann
	doc/design-impexp2.rst \
279 ed9fda24 Michael Hanselmann
	doc/design-lu-generated-jobs.rst \
280 d9bdffc3 René Nussbaumer
	doc/cluster-merge.rst \
281 a997cec5 Apollon Oikonomopoulos
	doc/design-shared-storage.rst \
282 62947ebb Michael Hanselmann
	doc/devnotes.rst \
283 e2078d28 Iustin Pop
	doc/glossary.rst \
284 4d6443f4 Iustin Pop
	doc/hooks.rst \
285 876860a3 Iustin Pop
	doc/iallocator.rst \
286 d17e74b4 Iustin Pop
	doc/index.rst \
287 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
288 28e15341 Iustin Pop
	doc/install.rst \
289 9725b53d Michael Hanselmann
	doc/locking.rst \
290 6bf273d5 Michael Hanselmann
	doc/move-instance.rst \
291 c71a1a3d Iustin Pop
	doc/news.rst \
292 6d81475c Iustin Pop
	doc/rapi.rst \
293 b76aac08 Michael Hanselmann
	doc/security.rst \
294 35dd762d Michael Hanselmann
	doc/upgrade.rst \
295 c71a1a3d Iustin Pop
	doc/walkthrough.rst
296 f05c99f3 Michael Hanselmann
297 c3f67183 Iustin Pop
HS_PROGS = \
298 d6159933 Iustin Pop
	htools/hbal \
299 d6159933 Iustin Pop
	htools/hscan \
300 d6159933 Iustin Pop
	htools/hail \
301 d6159933 Iustin Pop
	htools/hspace
302 d6159933 Iustin Pop
303 c3f67183 Iustin Pop
HS_ALL_PROGS = $(HS_PROGS) htools/test
304 c3f67183 Iustin Pop
HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
305 d6159933 Iustin Pop
# we don't add -Werror by default
306 d5506465 Iustin Pop
HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
307 b91e9518 Iustin Pop
# extra flags that can be overriden on the command line
308 d6159933 Iustin Pop
HEXTRA =
309 b91e9518 Iustin Pop
# exclude options for coverage reports
310 b91e9518 Iustin Pop
HPCEXCL = --exclude Main --exclude Ganeti.HTools.QC
311 d6159933 Iustin Pop
312 c3f67183 Iustin Pop
HS_LIB_SRCS = \
313 d6159933 Iustin Pop
	htools/Ganeti/HTools/CLI.hs \
314 d6159933 Iustin Pop
	htools/Ganeti/HTools/Cluster.hs \
315 d6159933 Iustin Pop
	htools/Ganeti/HTools/Container.hs \
316 d6159933 Iustin Pop
	htools/Ganeti/HTools/ExtLoader.hs \
317 d6159933 Iustin Pop
	htools/Ganeti/HTools/Group.hs \
318 d6159933 Iustin Pop
	htools/Ganeti/HTools/IAlloc.hs \
319 d6159933 Iustin Pop
	htools/Ganeti/HTools/Instance.hs \
320 d6159933 Iustin Pop
	htools/Ganeti/HTools/Loader.hs \
321 d6159933 Iustin Pop
	htools/Ganeti/HTools/Luxi.hs \
322 d6159933 Iustin Pop
	htools/Ganeti/HTools/Node.hs \
323 d6159933 Iustin Pop
	htools/Ganeti/HTools/PeerMap.hs \
324 d6159933 Iustin Pop
	htools/Ganeti/HTools/QC.hs \
325 d6159933 Iustin Pop
	htools/Ganeti/HTools/Rapi.hs \
326 d6159933 Iustin Pop
	htools/Ganeti/HTools/Simu.hs \
327 d6159933 Iustin Pop
	htools/Ganeti/HTools/Text.hs \
328 d6159933 Iustin Pop
	htools/Ganeti/HTools/Types.hs \
329 d6159933 Iustin Pop
	htools/Ganeti/HTools/Utils.hs \
330 d6159933 Iustin Pop
	htools/Ganeti/Jobs.hs \
331 d6159933 Iustin Pop
	htools/Ganeti/Luxi.hs \
332 d6159933 Iustin Pop
	htools/Ganeti/OpCodes.hs
333 d6159933 Iustin Pop
334 c3f67183 Iustin Pop
HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs
335 c3f67183 Iustin Pop
HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
336 d6159933 Iustin Pop
337 c964d962 Michael Hanselmann
$(RUN_IN_TEMPDIR): | $(all_dirfiles)
338 c964d962 Michael Hanselmann
339 a2d917f3 Iustin Pop
# Note: we use here an order-only prerequisite, as the contents of
340 a2d917f3 Iustin Pop
# _autoconf.py are not actually influencing the html build output: it
341 a2d917f3 Iustin Pop
# has to exist in order for the sphinx module to be loaded
342 a2d917f3 Iustin Pop
# successfully, but we certainly don't want the docs to be rebuilt if
343 a2d917f3 Iustin Pop
# it changes
344 c964d962 Michael Hanselmann
doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
345 a2d917f3 Iustin Pop
	$(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
346 a2d917f3 Iustin Pop
	| lib/_autoconf.py
347 d17e74b4 Iustin Pop
	@test -n "$(SPHINX)" || \
348 d17e74b4 Iustin Pop
	    { echo 'sphinx-build' not found during configure; exit 1; }
349 2750b299 Michael Hanselmann
	@mkdir_p@ $(dir $@)
350 e7f6524c Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
351 13de7d59 Michael Hanselmann
	    -d . \
352 d17e74b4 Iustin Pop
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
353 d17e74b4 Iustin Pop
	    -D release="$(PACKAGE_VERSION)" \
354 13de7d59 Michael Hanselmann
	    $(abs_top_srcdir)/doc $(CURDIR)/doc/html
355 13de7d59 Michael Hanselmann
	rm -f doc/html/.buildinfo doc/html/objects.inv
356 13de7d59 Michael Hanselmann
	touch $@
357 13de7d59 Michael Hanselmann
358 c964d962 Michael Hanselmann
doc/html: doc/html/index.html
359 2ab2b9f5 Iustin Pop
360 cbf3d64b Michael Hanselmann
doc/install-quick.rst: INSTALL
361 b76aac08 Michael Hanselmann
doc/news.rst: NEWS
362 7a03d293 Michael Hanselmann
doc/upgrade.rst: UPGRADE
363 b76aac08 Michael Hanselmann
364 e8deef56 Michael Hanselmann
doc/install-quick.rst doc/news.rst doc/upgrade.rst:
365 cbf3d64b Michael Hanselmann
	set -e; \
366 cbf3d64b Michael Hanselmann
	{ echo '.. This file is automatically updated at build time from $<.'; \
367 cbf3d64b Michael Hanselmann
	  echo '.. Do not edit.'; \
368 cbf3d64b Michael Hanselmann
	  echo; \
369 cbf3d64b Michael Hanselmann
	  cat $<; \
370 cbf3d64b Michael Hanselmann
	} > $@
371 cbf3d64b Michael Hanselmann
372 b8195800 Iustin Pop
docdot = \
373 ca9ccea8 Michael Hanselmann
	doc/arch-2.0.dot \
374 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-acquire.dot \
375 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-release.dot
376 b8195800 Iustin Pop
377 d17e74b4 Iustin Pop
docpng = $(patsubst %.dot,%.png,$(docdot))
378 e8230860 Michael Hanselmann
379 7e1ccbe0 Michael Hanselmann
# Things to build but not to install (add it to EXTRA_DIST if it should be
380 7e1ccbe0 Michael Hanselmann
# distributed)
381 7e1ccbe0 Michael Hanselmann
noinst_DATA = \
382 7e1ccbe0 Michael Hanselmann
	devel/upload \
383 7e1ccbe0 Michael Hanselmann
	doc/html \
384 7e1ccbe0 Michael Hanselmann
	doc/examples/bash_completion \
385 7e1ccbe0 Michael Hanselmann
	doc/examples/ganeti.cron \
386 7e1ccbe0 Michael Hanselmann
	doc/examples/ganeti.initd \
387 5d9e167a Miguel Di Ciurcio Filho
	doc/examples/ganeti-kvm-poweroff.initd \
388 679008e7 Iustin Pop
	doc/examples/gnt-config-backup \
389 7e1ccbe0 Michael Hanselmann
	doc/examples/hooks/ipsec \
390 7e1ccbe0 Michael Hanselmann
	$(manhtml)
391 f29266b4 Iustin Pop
392 4f3d5b76 Michael Hanselmann
gnt_scripts = \
393 e8230860 Michael Hanselmann
	scripts/gnt-backup \
394 e8230860 Michael Hanselmann
	scripts/gnt-cluster \
395 e8230860 Michael Hanselmann
	scripts/gnt-debug \
396 667dbd6b Adeodato Simo
	scripts/gnt-group \
397 e8230860 Michael Hanselmann
	scripts/gnt-instance \
398 e8230860 Michael Hanselmann
	scripts/gnt-job \
399 e8230860 Michael Hanselmann
	scripts/gnt-node \
400 e8230860 Michael Hanselmann
	scripts/gnt-os
401 e8230860 Michael Hanselmann
402 c2855a12 Michael Hanselmann
PYTHON_BOOTSTRAP = \
403 5c9c0e0e Michael Hanselmann
	daemons/ganeti-confd \
404 29d91329 Michael Hanselmann
	daemons/ganeti-masterd \
405 5119f2ec Michael Hanselmann
	daemons/ganeti-noded \
406 9f4bb951 Michael Hanselmann
	daemons/ganeti-watcher \
407 d9c82a4e Michael Hanselmann
	daemons/ganeti-rapi \
408 02266fe0 Michael Hanselmann
	scripts/gnt-backup \
409 7b3e7d41 Michael Hanselmann
	scripts/gnt-cluster \
410 6d50f5f9 Michael Hanselmann
	scripts/gnt-debug \
411 667dbd6b Adeodato Simo
	scripts/gnt-group \
412 e792102d Michael Hanselmann
	scripts/gnt-instance \
413 a09b9e3d Michael Hanselmann
	scripts/gnt-job \
414 37494fa4 Michael Hanselmann
	scripts/gnt-node \
415 6d50f5f9 Michael Hanselmann
	scripts/gnt-os
416 2d48a3a2 Michael Hanselmann
417 a8c68e44 Michael Hanselmann
qa_scripts = \
418 a8c68e44 Michael Hanselmann
	qa/ganeti-qa.py \
419 a8c68e44 Michael Hanselmann
	qa/qa_cluster.py \
420 a8c68e44 Michael Hanselmann
	qa/qa_config.py \
421 a8c68e44 Michael Hanselmann
	qa/qa_daemon.py \
422 a8c68e44 Michael Hanselmann
	qa/qa_env.py \
423 a8c68e44 Michael Hanselmann
	qa/qa_error.py \
424 a8c68e44 Michael Hanselmann
	qa/qa_instance.py \
425 a8c68e44 Michael Hanselmann
	qa/qa_node.py \
426 a8c68e44 Michael Hanselmann
	qa/qa_os.py \
427 a8c68e44 Michael Hanselmann
	qa/qa_rapi.py \
428 a8c68e44 Michael Hanselmann
	qa/qa_tags.py \
429 a8c68e44 Michael Hanselmann
	qa/qa_utils.py
430 a8c68e44 Michael Hanselmann
431 d6159933 Iustin Pop
bin_SCRIPTS =
432 7617fd6b Iustin Pop
iallocators_SCRIPTS =
433 d6159933 Iustin Pop
if WANT_HTOOLS
434 c3f67183 Iustin Pop
bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
435 c3f67183 Iustin Pop
iallocators_SCRIPTS += $(filter htools/hail,$(HS_PROGS))
436 d6159933 Iustin Pop
endif
437 d6159933 Iustin Pop
438 c3f67183 Iustin Pop
$(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
439 d5506465 Iustin Pop
	BINARY=$(@:htools/%=%); \
440 d5506465 Iustin Pop
	$(GHC) --make \
441 d5506465 Iustin Pop
	  $(HFLAGS) $(HEXTRA) $(HTOOLS_NOCURL) \
442 d5506465 Iustin Pop
	  -osuf $$BINARY.o -hisuf $$BINARY.hi \
443 d5506465 Iustin Pop
	  $@
444 d6159933 Iustin Pop
445 b91e9518 Iustin Pop
# for the htools/test binary, we need to enable profiling/coverage
446 b91e9518 Iustin Pop
htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
447 b91e9518 Iustin Pop
	-fno-warn-monomorphism-restriction -fno-warn-orphans \
448 b91e9518 Iustin Pop
	-fno-warn-missing-methods -fno-warn-unused-imports
449 b91e9518 Iustin Pop
450 da7e44ee Michael Hanselmann
dist_sbin_SCRIPTS = \
451 da7e44ee Michael Hanselmann
	tools/ganeti-listrunner
452 4f3d5b76 Michael Hanselmann
453 fc3fd894 Michael Hanselmann
nodist_sbin_SCRIPTS = \
454 2d48a3a2 Michael Hanselmann
	$(PYTHON_BOOTSTRAP) \
455 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner
456 fc3fd894 Michael Hanselmann
457 e8230860 Michael Hanselmann
dist_tools_SCRIPTS = \
458 e8230860 Michael Hanselmann
	tools/burnin \
459 e8230860 Michael Hanselmann
	tools/cfgshell \
460 e8230860 Michael Hanselmann
	tools/cfgupgrade \
461 b5672ea0 Iustin Pop
	tools/cfgupgrade12 \
462 1f7d3f7d René Nussbaumer
	tools/cluster-merge \
463 ea5fd476 Iustin Pop
	tools/lvmstrap \
464 6bf273d5 Michael Hanselmann
	tools/move-instance \
465 05cd934d René Nussbaumer
	tools/setup-ssh \
466 ea5fd476 Iustin Pop
	tools/sanitize-config
467 e8230860 Michael Hanselmann
468 2d76b580 Michael Hanselmann
pkglib_python_scripts = \
469 c6ccba7e Michael Hanselmann
	daemons/import-export \
470 c6ccba7e Michael Hanselmann
	tools/check-cert-expired
471 2d76b580 Michael Hanselmann
472 f154a7a3 Michael Hanselmann
pkglib_SCRIPTS = \
473 2d76b580 Michael Hanselmann
	daemons/daemon-util \
474 46a8da3b René Nussbaumer
	daemons/ensure-dirs \
475 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
476 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts)
477 f154a7a3 Michael Hanselmann
478 e8230860 Michael Hanselmann
EXTRA_DIST = \
479 e8230860 Michael Hanselmann
	NEWS \
480 7a03d293 Michael Hanselmann
	UPGRADE \
481 f774bd03 Michael Hanselmann
	epydoc.conf.in \
482 70c771f6 Michael Hanselmann
	pylintrc \
483 bb46a96c Michael Hanselmann
	autotools/build-bash-completion \
484 eed5c5df Michael Hanselmann
	autotools/check-python-code \
485 a4f12da4 Michael Hanselmann
	autotools/check-man \
486 c81ed2b2 Michael Hanselmann
	autotools/check-news \
487 e627fe09 Michael Hanselmann
	autotools/check-tar \
488 96602be4 Michael Hanselmann
	autotools/check-version \
489 95eb4188 Michael Hanselmann
	autotools/docpp \
490 27e336af Michael Hanselmann
	autotools/gen-coverage \
491 e8c8cf1a Michael Hanselmann
	autotools/testrunner \
492 f3313af5 Guido Trotter
	$(RUN_IN_TEMPDIR) \
493 f154a7a3 Michael Hanselmann
	daemons/daemon-util.in \
494 46a8da3b René Nussbaumer
	daemons/ensure-dirs.in \
495 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner.in \
496 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
497 e8230860 Michael Hanselmann
	devel/upload.in \
498 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup.in \
499 b8195800 Iustin Pop
	$(docdot) \
500 f727d134 Michael Hanselmann
	$(docpng) \
501 d17e74b4 Iustin Pop
	$(docrst) \
502 d17e74b4 Iustin Pop
	doc/conf.py \
503 d17e74b4 Iustin Pop
	doc/html \
504 e8230860 Michael Hanselmann
	doc/examples/ganeti.initd.in \
505 5d9e167a Miguel Di Ciurcio Filho
	doc/examples/ganeti-kvm-poweroff.initd.in \
506 e8230860 Michael Hanselmann
	doc/examples/ganeti.cron.in \
507 679008e7 Iustin Pop
	doc/examples/gnt-config-backup.in \
508 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default \
509 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default-debug \
510 d6d9ce45 Guido Trotter
	doc/examples/hooks/ethers \
511 a2442bf9 Luca Bigliardi
	doc/examples/hooks/ipsec.in \
512 89c04c2d Guido Trotter
	doc/examples/gnt-debug/README \
513 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay0.json \
514 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay50.json \
515 e8230860 Michael Hanselmann
	test/testutils.py \
516 e8230860 Michael Hanselmann
	test/mocks.py \
517 e8230860 Michael Hanselmann
	$(dist_TESTS) \
518 e8230860 Michael Hanselmann
	$(TEST_FILES) \
519 6be8e2bf Iustin Pop
	man/footer.rst \
520 6be8e2bf Iustin Pop
	$(manrst) \
521 f727d134 Michael Hanselmann
	$(maninput) \
522 39e0d19e Michael Hanselmann
	qa/qa-sample.json \
523 d6159933 Iustin Pop
	$(qa_scripts) \
524 c3f67183 Iustin Pop
	$(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
525 c3f67183 Iustin Pop
	$(HS_PROG_SRCS)
526 e8230860 Michael Hanselmann
527 e8230860 Michael Hanselmann
man_MANS = \
528 e8230860 Michael Hanselmann
	man/ganeti.7 \
529 bae7e531 Michael Hanselmann
	man/ganeti-cleaner.8 \
530 b7b7cda6 Guido Trotter
	man/ganeti-confd.8 \
531 da7e44ee Michael Hanselmann
	man/ganeti-listrunner.8 \
532 320d986d Iustin Pop
	man/ganeti-masterd.8 \
533 e8230860 Michael Hanselmann
	man/ganeti-noded.8 \
534 e8230860 Michael Hanselmann
	man/ganeti-os-interface.7 \
535 320d986d Iustin Pop
	man/ganeti-rapi.8 \
536 e8230860 Michael Hanselmann
	man/ganeti-watcher.8 \
537 e8230860 Michael Hanselmann
	man/gnt-backup.8 \
538 e8230860 Michael Hanselmann
	man/gnt-cluster.8 \
539 d3b4cf9f Iustin Pop
	man/gnt-debug.8 \
540 667dbd6b Adeodato Simo
	man/gnt-group.8 \
541 e8230860 Michael Hanselmann
	man/gnt-instance.8 \
542 d3b4cf9f Iustin Pop
	man/gnt-job.8 \
543 e8230860 Michael Hanselmann
	man/gnt-node.8 \
544 5a19bd35 Iustin Pop
	man/gnt-os.8 \
545 5a19bd35 Iustin Pop
	man/hail.1 \
546 5a19bd35 Iustin Pop
	man/hbal.1 \
547 5a19bd35 Iustin Pop
	man/hscan.1 \
548 5a19bd35 Iustin Pop
	man/hspace.1
549 e8230860 Michael Hanselmann
550 5a19bd35 Iustin Pop
manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
551 6be8e2bf Iustin Pop
manhtml = $(patsubst %.rst,%.html,$(manrst))
552 fcdb582d Michael Hanselmann
mangen = $(patsubst %.rst,%.gen,$(manrst))
553 25c92bc5 Michael Hanselmann
maninput = \
554 5a19bd35 Iustin Pop
	$(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
555 de8eea3e Iustin Pop
	$(patsubst %.html,%.html.in,$(manhtml)) \
556 fcdb582d Michael Hanselmann
	man/footer.man man/footer.html $(mangen)
557 e8230860 Michael Hanselmann
558 e8230860 Michael Hanselmann
TEST_FILES = \
559 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.0.txt \
560 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.3.txt \
561 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-disk.txt \
562 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip4.txt \
563 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip6.txt \
564 27e46076 Michael Hanselmann
	test/data/cert1.pem \
565 d816408a Iustin Pop
	test/data/proc_drbd8.txt \
566 a6ac80db Iustin Pop
	test/data/proc_drbd80-emptyline.txt \
567 2d76b580 Michael Hanselmann
	test/data/proc_drbd83.txt \
568 549071a0 Luca Bigliardi
	test/data/sys_drbd_usermode_helper.txt \
569 2d76b580 Michael Hanselmann
	test/import-export_unittest-helper
570 e8230860 Michael Hanselmann
571 e8c8cf1a Michael Hanselmann
python_tests = \
572 17496050 Guido Trotter
	test/ganeti.asyncnotifier_unittest.py \
573 f942a838 Michael Hanselmann
	test/ganeti.backend_unittest.py \
574 6de7c41d Iustin Pop
	test/ganeti.bdev_unittest.py \
575 6de7c41d Iustin Pop
	test/ganeti.cli_unittest.py \
576 66d1f035 René Nussbaumer
	test/ganeti.client.gnt_cluster_unittest.py \
577 25ce3ec4 Michael Hanselmann
	test/ganeti.client.gnt_instance_unittest.py \
578 1118ec44 Guido Trotter
	test/ganeti.daemon_unittest.py \
579 6de7c41d Iustin Pop
	test/ganeti.cmdlib_unittest.py \
580 cea881e5 Michael Hanselmann
	test/ganeti.compat_unittest.py \
581 edf7d66e Iustin Pop
	test/ganeti.confd.client_unittest.py \
582 e8230860 Michael Hanselmann
	test/ganeti.config_unittest.py \
583 6de7c41d Iustin Pop
	test/ganeti.constants_unittest.py \
584 3bd19c66 Michael Hanselmann
	test/ganeti.errors_unittest.py \
585 e8230860 Michael Hanselmann
	test/ganeti.hooks_unittest.py \
586 ecdf0398 Michael Hanselmann
	test/ganeti.ht_unittest.py \
587 6de7c41d Iustin Pop
	test/ganeti.http_unittest.py \
588 b7d82e40 Iustin Pop
	test/ganeti.hypervisor_unittest.py \
589 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_chroot_unittest.py \
590 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_fake_unittest.py \
591 748e4b5a Michael Hanselmann
	test/ganeti.hypervisor.hv_kvm_unittest.py \
592 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_lxc_unittest.py \
593 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_xen_unittest.py \
594 bb44b1ae Michael Hanselmann
	test/ganeti.impexpd_unittest.py \
595 989a8bee Michael Hanselmann
	test/ganeti.jqueue_unittest.py \
596 e8230860 Michael Hanselmann
	test/ganeti.locking_unittest.py \
597 231db3a5 Michael Hanselmann
	test/ganeti.luxi_unittest.py \
598 033a1d00 Michael Hanselmann
	test/ganeti.masterd.instance_unittest.py \
599 407339d0 Michael Hanselmann
	test/ganeti.mcpu_unittest.py \
600 a744b676 Manuel Franceschini
	test/ganeti.netutils_unittest.py \
601 4c14965f Guido Trotter
	test/ganeti.objects_unittest.py \
602 c32b908e Michael Hanselmann
	test/ganeti.opcodes_unittest.py \
603 a123dc19 Michael Hanselmann
	test/ganeti.qlang_unittest.py \
604 4ca96421 Michael Hanselmann
	test/ganeti.query_unittest.py \
605 cfaeaaf7 Michael Hanselmann
	test/ganeti.rapi.baserlib_unittest.py \
606 95ab4de9 David Knowles
	test/ganeti.rapi.client_unittest.py \
607 4cbd4462 Oleksiy Mishchenko
	test/ganeti.rapi.resources_unittest.py \
608 6395cebb Michael Hanselmann
	test/ganeti.rapi.rlib2_unittest.py \
609 33231500 Michael Hanselmann
	test/ganeti.rpc_unittest.py \
610 f12e1736 René Nussbaumer
	test/ganeti.runtime_unittest.py \
611 6de7c41d Iustin Pop
	test/ganeti.serializer_unittest.py \
612 6de7c41d Iustin Pop
	test/ganeti.ssh_unittest.py \
613 93be53da Balazs Lecz
	test/ganeti.uidpool_unittest.py \
614 4fd029cf Michael Hanselmann
	test/ganeti.utils.algo_unittest.py \
615 9d1b963f Michael Hanselmann
	test/ganeti.utils.filelock_unittest.py \
616 f21bb4b7 Michael Hanselmann
	test/ganeti.utils.hash_unittest.py \
617 3865ca48 Michael Hanselmann
	test/ganeti.utils.io_unittest.py \
618 b6fa9a44 Michael Hanselmann
	test/ganeti.utils.log_unittest.py \
619 36a4acd4 Michael Hanselmann
	test/ganeti.utils.mlock_unittest.py \
620 17b97ab3 Michael Hanselmann
	test/ganeti.utils.nodesetup_unittest.py \
621 a4ccecf6 Michael Hanselmann
	test/ganeti.utils.process_unittest.py \
622 79d22269 Michael Hanselmann
	test/ganeti.utils.retry_unittest.py \
623 7fcffe27 Michael Hanselmann
	test/ganeti.utils.text_unittest.py \
624 7831fc5f Michael Hanselmann
	test/ganeti.utils.wrapper_unittest.py \
625 c50645c0 Michael Hanselmann
	test/ganeti.utils.x509_unittest.py \
626 4fd029cf Michael Hanselmann
	test/ganeti.utils_unittest.py \
627 3f991867 Michael Hanselmann
	test/ganeti.workerpool_unittest.py \
628 aefbe369 Michael Hanselmann
	test/cfgupgrade_unittest.py \
629 055f822b Michael Hanselmann
	test/docs_unittest.py \
630 055f822b Michael Hanselmann
	test/tempfile_fork_unittest.py
631 e8230860 Michael Hanselmann
632 b91e9518 Iustin Pop
haskell_tests = htools/test
633 b91e9518 Iustin Pop
634 e8c8cf1a Michael Hanselmann
dist_TESTS = \
635 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
636 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
637 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
638 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
639 e8c8cf1a Michael Hanselmann
	$(python_tests)
640 e8c8cf1a Michael Hanselmann
641 e8230860 Michael Hanselmann
nodist_TESTS =
642 b91e9518 Iustin Pop
if WANT_HTOOLS
643 b91e9518 Iustin Pop
nodist_TESTS += $(haskell_tests)
644 b91e9518 Iustin Pop
endif
645 e8230860 Michael Hanselmann
646 e8230860 Michael Hanselmann
TESTS = $(dist_TESTS) $(nodist_TESTS)
647 e8230860 Michael Hanselmann
648 27e336af Michael Hanselmann
# Environment for all tests
649 27e336af Michael Hanselmann
PLAIN_TESTS_ENVIRONMENT = \
650 27e336af Michael Hanselmann
	PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
651 27e336af Michael Hanselmann
652 27e336af Michael Hanselmann
# Environment for tests run by automake
653 f848ac00 Michael Hanselmann
TESTS_ENVIRONMENT = \
654 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
655 6e06b36c Iustin Pop
656 eed5c5df Michael Hanselmann
all_python_code = \
657 01a3a718 Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
658 01a3a718 Michael Hanselmann
	$(dist_tools_SCRIPTS) \
659 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
660 e8c8cf1a Michael Hanselmann
	$(python_tests) \
661 01a3a718 Michael Hanselmann
	$(pkgpython_PYTHON) \
662 2d48a3a2 Michael Hanselmann
	$(client_PYTHON) \
663 01a3a718 Michael Hanselmann
	$(hypervisor_PYTHON) \
664 01a3a718 Michael Hanselmann
	$(rapi_PYTHON) \
665 899c4d2c Michael Hanselmann
	$(server_PYTHON) \
666 01a3a718 Michael Hanselmann
	$(http_PYTHON) \
667 01a3a718 Michael Hanselmann
	$(confd_PYTHON) \
668 dc101ecc Michael Hanselmann
	$(masterd_PYTHON) \
669 bb44b1ae Michael Hanselmann
	$(impexpd_PYTHON) \
670 c047a981 Michael Hanselmann
	$(utils_PYTHON) \
671 9f4bb951 Michael Hanselmann
	$(watcher_PYTHON) \
672 a8c68e44 Michael Hanselmann
	$(noinst_PYTHON) \
673 a8c68e44 Michael Hanselmann
	$(qa_scripts)
674 01a3a718 Michael Hanselmann
675 eed5c5df Michael Hanselmann
srclink_files = \
676 6be8e2bf Iustin Pop
	man/footer.rst \
677 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
678 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
679 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
680 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
681 d6159933 Iustin Pop
	$(all_python_code) \
682 c3f67183 Iustin Pop
	$(HS_LIB_SRCS) $(HS_PROG_SRCS)
683 eed5c5df Michael Hanselmann
684 eed5c5df Michael Hanselmann
check_python_code = \
685 e4e7c7df Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
686 95eb4188 Michael Hanselmann
	$(DOCPP) \
687 eed5c5df Michael Hanselmann
	$(all_python_code)
688 eed5c5df Michael Hanselmann
689 e4e7c7df Michael Hanselmann
lint_python_code = \
690 f60d352e Michael Hanselmann
	ganeti \
691 f1763373 Iustin Pop
	ganeti/http/server.py \
692 f60d352e Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
693 f60d352e Michael Hanselmann
	$(dist_tools_SCRIPTS) \
694 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
695 2cc8bdd0 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
696 95eb4188 Michael Hanselmann
	$(DOCPP) \
697 2cc8bdd0 Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
698 eed5c5df Michael Hanselmann
699 571b34f8 Michael Hanselmann
test/daemon-util_unittest.bash: daemons/daemon-util
700 571b34f8 Michael Hanselmann
701 7172f605 Michael Hanselmann
test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
702 7172f605 Michael Hanselmann
703 26916aad Apollon Oikonomopoulos
tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
704 26916aad Apollon Oikonomopoulos
	sed -f $(REPLACE_VARS_SED) < $< > $@
705 26916aad Apollon Oikonomopoulos
	chmod +x $@
706 26916aad Apollon Oikonomopoulos
707 dbefcc7e Michael Hanselmann
devel/upload: devel/upload.in $(REPLACE_VARS_SED)
708 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
709 e8230860 Michael Hanselmann
	chmod u+x $@
710 e8230860 Michael Hanselmann
711 c964d962 Michael Hanselmann
daemons/%: daemons/%.in $(REPLACE_VARS_SED)
712 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
713 5c566e17 Michael Hanselmann
	chmod +x $@
714 e8230860 Michael Hanselmann
715 c964d962 Michael Hanselmann
doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
716 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
717 e8230860 Michael Hanselmann
718 c964d962 Michael Hanselmann
doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
719 a2442bf9 Luca Bigliardi
	sed -f $(REPLACE_VARS_SED) < $< > $@
720 a2442bf9 Luca Bigliardi
721 b959138f Michael Hanselmann
doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
722 88a6ca6f Michael Hanselmann
	lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
723 b959138f Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
724 4f3d5b76 Michael Hanselmann
725 f86e82ef Iustin Pop
doc/%.png: doc/%.dot
726 2ab2b9f5 Iustin Pop
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
727 f86e82ef Iustin Pop
	$(DOT) -Tpng -o $@ $<
728 f86e82ef Iustin Pop
729 de8eea3e Iustin Pop
man/footer.man: man/footer.rst
730 de8eea3e Iustin Pop
	@test -n "$(PANDOC)" || \
731 de8eea3e Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
732 de8eea3e Iustin Pop
	$(PANDOC) -f rst -t man -o $@ $<
733 de8eea3e Iustin Pop
734 6be8e2bf Iustin Pop
man/footer.html: man/footer.rst
735 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
736 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
737 6be8e2bf Iustin Pop
	$(PANDOC) -f rst -t html -o $@ $<
738 6be8e2bf Iustin Pop
739 fcdb582d Michael Hanselmann
man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
740 fcdb582d Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
741 fcdb582d Michael Hanselmann
742 5a19bd35 Iustin Pop
man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
743 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
744 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
745 a01dd3c6 Iustin Pop
	set -o pipefail ; \
746 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t man -A man/footer.man $< | \
747 6be8e2bf Iustin Pop
	  sed -e 's/\\@/@/g' > $@
748 5f55173b Iustin Pop
	if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
749 2ab2b9f5 Iustin Pop
750 fcdb582d Michael Hanselmann
man/%.html.in: man/%.gen man/footer.html
751 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
752 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
753 a01dd3c6 Iustin Pop
	set -o pipefail ; \
754 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t html -A man/footer.html $< | \
755 6be8e2bf Iustin Pop
	  sed -e 's/\\@/@/g' > $@
756 6be8e2bf Iustin Pop
757 5a19bd35 Iustin Pop
man/%.1: man/%.1.in $(REPLACE_VARS_SED)
758 5a19bd35 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
759 5a19bd35 Iustin Pop
760 dbefcc7e Michael Hanselmann
man/%.7: man/%.7.in $(REPLACE_VARS_SED)
761 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
762 e8230860 Michael Hanselmann
763 dbefcc7e Michael Hanselmann
man/%.8: man/%.8.in $(REPLACE_VARS_SED)
764 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
765 e8230860 Michael Hanselmann
766 dbefcc7e Michael Hanselmann
man/%.html: man/%.html.in $(REPLACE_VARS_SED)
767 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
768 f29266b4 Iustin Pop
769 75f76703 Michael Hanselmann
epydoc.conf: epydoc.conf.in Makefile
770 75f76703 Michael Hanselmann
	sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
771 f774bd03 Michael Hanselmann
772 84a12e40 Iustin Pop
vcs-version:
773 84a12e40 Iustin Pop
	if test -d .git; then \
774 84a12e40 Iustin Pop
	  git describe > $@; \
775 84a12e40 Iustin Pop
	elif test ! -f $@ ; then \
776 84a12e40 Iustin Pop
	  echo "Cannot auto-generate $@ file"; exit 1; \
777 84a12e40 Iustin Pop
	fi
778 84a12e40 Iustin Pop
779 84a12e40 Iustin Pop
.PHONY: regen-vcs-version
780 84a12e40 Iustin Pop
regen-vcs-version:
781 e8230860 Michael Hanselmann
	set -e; \
782 84a12e40 Iustin Pop
	cd $(srcdir); \
783 84a12e40 Iustin Pop
	if test -d .git; then \
784 84a12e40 Iustin Pop
	  rm -f vcs-version; \
785 84a12e40 Iustin Pop
	  $(MAKE) vcs-version; \
786 84a12e40 Iustin Pop
	fi
787 84a12e40 Iustin Pop
788 d6159933 Iustin Pop
htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
789 d6159933 Iustin Pop
	set -e; \
790 d6159933 Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
791 d6159933 Iustin Pop
	sed -e "s/%ver%/$$VCSVER/" < $< > $@
792 d6159933 Iustin Pop
793 c964d962 Michael Hanselmann
lib/_autoconf.py: Makefile vcs-version | lib/.dir
794 84a12e40 Iustin Pop
	set -e; \
795 84a12e40 Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
796 e8230860 Michael Hanselmann
	{ echo '# This file is automatically generated, do not edit!'; \
797 e8230860 Michael Hanselmann
	  echo '#'; \
798 67047322 Iustin Pop
	  echo ''; \
799 67047322 Iustin Pop
	  echo '"""Build-time configuration for Ganeti.'; \
800 67047322 Iustin Pop
	  echo '';\
801 67047322 Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
802 67047322 Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
803 67047322 Iustin Pop
	  echo 'not edit by hand).'; \
804 67047322 Iustin Pop
	  echo ''; \
805 67047322 Iustin Pop
	  echo '"""'; \
806 67047322 Iustin Pop
	  echo ''; \
807 0a4e7f24 Iustin Pop
	  echo '# pylint: disable-msg=C0301,C0324'; \
808 0a4e7f24 Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
809 0a4e7f24 Iustin Pop
	  echo '# style warnings' ; \
810 0a4e7f24 Iustin Pop
	  echo ''; \
811 e8230860 Michael Hanselmann
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
812 e8230860 Michael Hanselmann
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
813 e8230860 Michael Hanselmann
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
814 e8230860 Michael Hanselmann
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
815 e8230860 Michael Hanselmann
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
816 e8230860 Michael Hanselmann
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
817 e8230860 Michael Hanselmann
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
818 e8230860 Michael Hanselmann
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
819 553bd93f Vitaly Kuznetsov
	  echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
820 e8230860 Michael Hanselmann
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
821 e8230860 Michael Hanselmann
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
822 2f2dbb4b Jun Futagawa
	  echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
823 e8230860 Michael Hanselmann
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
824 e8230860 Michael Hanselmann
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
825 e8230860 Michael Hanselmann
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
826 cb7c0198 Iustin Pop
	  echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
827 4b97f902 Apollon Oikonomopoulos
	  echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
828 4b97f902 Apollon Oikonomopoulos
	  echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
829 e8230860 Michael Hanselmann
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
830 7e2c5b9e Guido Trotter
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
831 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_PATH = '$(SOCAT)'"; \
832 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
833 e90739d6 Michael Hanselmann
	  echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
834 bea60381 Michael Hanselmann
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
835 bea60381 Michael Hanselmann
	  echo "TOOLSDIR = '$(toolsdir)'"; \
836 4f3d5b76 Michael Hanselmann
	  echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
837 f154a7a3 Michael Hanselmann
	  echo "PKGLIBDIR = '$(pkglibdir)'"; \
838 89b70f39 Iustin Pop
	  echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
839 551b6283 Iustin Pop
	  echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
840 8b72b05c René Nussbaumer
	  echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
841 f12e1736 René Nussbaumer
	  echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
842 8b72b05c René Nussbaumer
	  echo "MASTERD_USER = '$(MASTERD_USER)'"; \
843 f12e1736 René Nussbaumer
	  echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
844 8b72b05c René Nussbaumer
	  echo "RAPI_USER = '$(RAPI_USER)'"; \
845 f12e1736 René Nussbaumer
	  echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
846 f12e1736 René Nussbaumer
	  echo "CONFD_USER = '$(CONFD_USER)'"; \
847 f12e1736 René Nussbaumer
	  echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
848 f12e1736 René Nussbaumer
	  echo "NODED_USER = '$(NODED_USER)'"; \
849 84a12e40 Iustin Pop
	  echo "VCS_VERSION = '$$VCSVER'"; \
850 3536c792 Iustin Pop
	  echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
851 e8230860 Michael Hanselmann
	} > $@
852 e8230860 Michael Hanselmann
853 dbefcc7e Michael Hanselmann
$(REPLACE_VARS_SED): Makefile
854 e8230860 Michael Hanselmann
	set -e; \
855 e8230860 Michael Hanselmann
	{ echo 's#@PREFIX@#$(prefix)#g'; \
856 e8230860 Michael Hanselmann
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
857 e8230860 Michael Hanselmann
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
858 7a2ba406 Luca Bigliardi
	  echo 's#@BINDIR@#$(bindir)#g'; \
859 e8230860 Michael Hanselmann
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
860 e8230860 Michael Hanselmann
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
861 2f2dbb4b Jun Futagawa
	  echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
862 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
863 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
864 56956bcb Iustin Pop
	  echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
865 56956bcb Iustin Pop
	  echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
866 d3b4cf9f Iustin Pop
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
867 7e1fac25 Michael Hanselmann
	  echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
868 c5159571 Iustin Pop
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
869 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
870 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
871 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
872 0d150c50 René Nussbaumer
	  echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
873 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
874 0d150c50 René Nussbaumer
	  echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
875 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
876 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
877 46a8da3b René Nussbaumer
	  echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
878 e8230860 Michael Hanselmann
	} > $@
879 e8230860 Michael Hanselmann
880 67313146 Michael Hanselmann
# Using deferred evaluation
881 899c4d2c Michael Hanselmann
daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
882 9f4bb951 Michael Hanselmann
daemons/ganeti-watcher: MODULE = ganeti.watcher
883 67313146 Michael Hanselmann
scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
884 67313146 Michael Hanselmann
885 c964d962 Michael Hanselmann
$(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
886 67313146 Michael Hanselmann
	test -n "$(MODULE)" || { echo Missing module; exit 1; }
887 2d48a3a2 Michael Hanselmann
	set -e; \
888 d75e738e Michael Hanselmann
	{ echo '#!/usr/bin/python'; \
889 2d48a3a2 Michael Hanselmann
	  echo '# This file is automatically generated, do not edit!'; \
890 67313146 Michael Hanselmann
	  echo "# Edit $(MODULE) instead."; \
891 2d48a3a2 Michael Hanselmann
	  echo; \
892 67313146 Michael Hanselmann
	  echo '"""Bootstrap script for L{$(MODULE)}"""'; \
893 2d48a3a2 Michael Hanselmann
	  echo; \
894 2d48a3a2 Michael Hanselmann
	  echo '# pylint: disable-msg=C0103'; \
895 2d48a3a2 Michael Hanselmann
	  echo '# C0103: Invalid name'; \
896 2d48a3a2 Michael Hanselmann
	  echo; \
897 2d48a3a2 Michael Hanselmann
	  echo 'import sys'; \
898 67313146 Michael Hanselmann
	  echo 'import $(MODULE) as main'; \
899 2d48a3a2 Michael Hanselmann
	  echo; \
900 2d48a3a2 Michael Hanselmann
	  echo '# Temporarily alias commands until bash completion'; \
901 2d48a3a2 Michael Hanselmann
	  echo '# generator is changed'; \
902 67313146 Michael Hanselmann
	  echo 'if hasattr(main, "commands"):'; \
903 2cc8bdd0 Michael Hanselmann
		echo '  commands = main.commands # pylint: disable-msg=E1101'; \
904 2d48a3a2 Michael Hanselmann
	  echo; \
905 2d48a3a2 Michael Hanselmann
	  echo 'if __name__ == "__main__":'; \
906 67313146 Michael Hanselmann
	  echo '  sys.exit(main.Main())'; \
907 2d48a3a2 Michael Hanselmann
	} > $@
908 2d48a3a2 Michael Hanselmann
	chmod u+x $@
909 2d48a3a2 Michael Hanselmann
910 e8230860 Michael Hanselmann
# We need to create symlinks because "make distcheck" will not install Python
911 e8230860 Michael Hanselmann
# files when building.
912 c964d962 Michael Hanselmann
stamp-srclinks: Makefile | $(all_dirfiles)
913 e8230860 Michael Hanselmann
	set -e; \
914 01a3a718 Michael Hanselmann
	for i in $(srclink_files); do \
915 e8230860 Michael Hanselmann
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
916 e8230860 Michael Hanselmann
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
917 e8230860 Michael Hanselmann
		fi; \
918 e8230860 Michael Hanselmann
	done
919 dd1dfd9a Michael Hanselmann
	touch $@
920 97a37b3f Michael Hanselmann
921 9ff7e35c Michael Hanselmann
.PHONY: ganeti
922 9ff7e35c Michael Hanselmann
ganeti:
923 01f3e7b1 Iustin Pop
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
924 9ff7e35c Michael Hanselmann
925 6b997854 Michael Hanselmann
.PHONY: check-dirs
926 6b997854 Michael Hanselmann
check-dirs: $(BUILT_SOURCES)
927 0c1103d6 Iustin Pop
	@set -e; \
928 6b997854 Michael Hanselmann
	find . -type d \( \( -name . \) -o \( \
929 6b997854 Michael Hanselmann
		-name .git -o \
930 6b997854 Michael Hanselmann
		-name autom4te.cache \
931 6b997854 Michael Hanselmann
		\) -prune -o -print \) | { \
932 6b997854 Michael Hanselmann
		error=; \
933 6b997854 Michael Hanselmann
		while read dir; do \
934 6b997854 Michael Hanselmann
			case "$$dir" in \
935 6b997854 Michael Hanselmann
				$(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
936 6b997854 Michael Hanselmann
				*) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
937 6b997854 Michael Hanselmann
			esac; \
938 6b997854 Michael Hanselmann
		done; \
939 6b997854 Michael Hanselmann
		for dir in $(DIRS); do \
940 6b997854 Michael Hanselmann
			if ! test -d "$$dir"; then \
941 6b997854 Michael Hanselmann
				echo "Directory $$dir listed in DIRS does not exist" >&2; \
942 6b997854 Michael Hanselmann
				error=1; \
943 6b997854 Michael Hanselmann
			fi \
944 6b997854 Michael Hanselmann
		done; \
945 6b997854 Michael Hanselmann
		if test -n "$$error"; then exit 1; else exit 0; fi; \
946 6b997854 Michael Hanselmann
	}
947 6b997854 Michael Hanselmann
948 6b997854 Michael Hanselmann
check-local: check-dirs
949 eed5c5df Michael Hanselmann
	$(CHECK_PYTHON_CODE) $(check_python_code)
950 35576615 Michael Hanselmann
	$(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
951 7385c51d Michael Hanselmann
	$(CHECK_NEWS) < $(top_srcdir)/NEWS
952 eed5c5df Michael Hanselmann
953 e0098923 Iustin Pop
.PHONY: lint
954 c964d962 Michael Hanselmann
lint: $(BUILT_SOURCES)
955 6d7cc5ff Michael Hanselmann
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
956 6d7cc5ff Michael Hanselmann
	$(PYLINT) $(LINT_OPTS) $(lint_python_code)
957 3582eef6 Iustin Pop
	cd $(top_srcdir)/qa && \
958 3582eef6 Iustin Pop
	  PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
959 3582eef6 Iustin Pop
	  --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
960 e0098923 Iustin Pop
961 191ff68c Iustin Pop
.PHONY: hlint
962 c3f67183 Iustin Pop
hlint: $(HS_BUILT_SRCS)
963 191ff68c Iustin Pop
	if tty -s; then C="-c"; else C=""; fi; \
964 191ff68c Iustin Pop
	hlint --report=doc/hs-lint.html $$C htools
965 191ff68c Iustin Pop
966 84a12e40 Iustin Pop
# a dist hook rule for updating the vcs-version file; this is
967 84a12e40 Iustin Pop
# hardcoded due to where it needs to build the file...
968 84a12e40 Iustin Pop
dist-hook:
969 84a12e40 Iustin Pop
	$(MAKE) regen-vcs-version && \
970 84a12e40 Iustin Pop
	rm -f $(top_distdir)/vcs-version && \
971 84a12e40 Iustin Pop
	cp -p $(srcdir)/vcs-version $(top_distdir)
972 84a12e40 Iustin Pop
973 84a12e40 Iustin Pop
# a distcheck hook rule for catching revision control directories
974 b6f2e47f Iustin Pop
distcheck-hook:
975 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name .svn -or -name .git | grep .; then \
976 c6aa0c42 Michael Hanselmann
		echo "Found revision control files in final archive." 1>&2; \
977 c6aa0c42 Michael Hanselmann
		exit 1; \
978 c6aa0c42 Michael Hanselmann
	fi
979 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*.py[co]' | grep .; then \
980 c6aa0c42 Michael Hanselmann
		echo "Found Python byte code in final archive." 1>&2; \
981 c6aa0c42 Michael Hanselmann
		exit 1; \
982 c6aa0c42 Michael Hanselmann
	fi
983 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*~' | grep .; then \
984 c6aa0c42 Michael Hanselmann
		echo "Found backup files in final archive." 1>&2; \
985 b6f2e47f Iustin Pop
		exit 1; \
986 b6f2e47f Iustin Pop
	fi
987 bf0b21da Michael Hanselmann
# Empty files or directories should not be distributed. They can cause
988 bf0b21da Michael Hanselmann
# unnecessary warnings for packagers. Directories used by automake during
989 bf0b21da Michael Hanselmann
# distcheck must be excluded.
990 bf0b21da Michael Hanselmann
	if find $(top_distdir) -empty -and -not \( \
991 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_build -or \
992 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_inst \) | grep .; then \
993 bf0b21da Michael Hanselmann
		echo "Found empty files or directories in final archive." 1>&2; \
994 bf0b21da Michael Hanselmann
		exit 1; \
995 bf0b21da Michael Hanselmann
	fi
996 c7b86f6c Michael Hanselmann
	if test -n "$(BUILD_RELEASE)" && \
997 c7b86f6c Michael Hanselmann
	   grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
998 c7b86f6c Michael Hanselmann
		echo "Found unreleased version in NEWS." >&2; \
999 c7b86f6c Michael Hanselmann
		exit 1; \
1000 c7b86f6c Michael Hanselmann
	fi
1001 c7b86f6c Michael Hanselmann
1002 c7b86f6c Michael Hanselmann
# When building a release, stricter checks should be used
1003 e627fe09 Michael Hanselmann
distcheck-release dist-release: export BUILD_RELEASE = 1
1004 c7b86f6c Michael Hanselmann
distcheck-release: distcheck
1005 b6f2e47f Iustin Pop
1006 e627fe09 Michael Hanselmann
dist-release: dist
1007 e627fe09 Michael Hanselmann
	set -e; \
1008 e627fe09 Michael Hanselmann
	for i in $(DIST_ARCHIVES); do \
1009 e627fe09 Michael Hanselmann
		echo -n "Checking $$i ... "; \
1010 e627fe09 Michael Hanselmann
		autotools/check-tar < $$i; \
1011 e627fe09 Michael Hanselmann
		echo OK; \
1012 e627fe09 Michael Hanselmann
	done
1013 e627fe09 Michael Hanselmann
1014 8925faaa Iustin Pop
install-exec-local:
1015 0d93b082 Michael Hanselmann
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1016 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
1017 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/run/ganeti"
1018 e8230860 Michael Hanselmann
1019 c964d962 Michael Hanselmann
# To avoid conflicts between directory names and other targets, a file inside
1020 c964d962 Michael Hanselmann
# the directory is used to ensure its existence.
1021 c964d962 Michael Hanselmann
%.dir:
1022 c964d962 Michael Hanselmann
	@mkdir_p@ $* && touch $@
1023 e8230860 Michael Hanselmann
1024 d128fdb6 Iustin Pop
.PHONY: apidoc
1025 a38bfce5 Iustin Pop
if WANT_HTOOLSAPIDOC
1026 a38bfce5 Iustin Pop
apidoc: py-apidoc hs-apidoc
1027 a38bfce5 Iustin Pop
else
1028 a38bfce5 Iustin Pop
apidoc: py-apidoc
1029 a38bfce5 Iustin Pop
endif
1030 a38bfce5 Iustin Pop
1031 a38bfce5 Iustin Pop
.PHONY: py-apidoc
1032 a38bfce5 Iustin Pop
py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1033 b959138f Michael Hanselmann
	$(RUN_IN_TEMPDIR) epydoc -v \
1034 b959138f Michael Hanselmann
		--conf $(CURDIR)/epydoc.conf \
1035 22c5390d Iustin Pop
		--output $(CURDIR)/$(APIDOC_PY_DIR)
1036 a38bfce5 Iustin Pop
1037 a38bfce5 Iustin Pop
.PHONY: hs-apidoc
1038 c3f67183 Iustin Pop
hs-apidoc: $(HS_BUILT_SRCS)
1039 a38bfce5 Iustin Pop
	@test -n "$(HSCOLOUR)" || \
1040 a38bfce5 Iustin Pop
	    { echo 'HsColour' not found during configure; exit 1; }
1041 a38bfce5 Iustin Pop
	@test -n "$(HADDOCK)" || \
1042 a38bfce5 Iustin Pop
	    { echo 'haddock' not found during configure; exit 1; }
1043 22c5390d Iustin Pop
	rm -rf $(APIDOC_HS_DIR)/*
1044 22c5390d Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools
1045 22c5390d Iustin Pop
	$(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1046 22c5390d Iustin Pop
	ln -s ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1047 a38bfce5 Iustin Pop
	set -e ; \
1048 a38bfce5 Iustin Pop
	cd htools; \
1049 c478f837 Iustin Pop
	if [ "$(HTOOLS_NOCURL)" ]; \
1050 c478f837 Iustin Pop
	then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1051 c478f837 Iustin Pop
	else OPTGHC=""; \
1052 c478f837 Iustin Pop
	fi; \
1053 c3f67183 Iustin Pop
	RELSRCS="$(HS_LIB_SRCS:htools/%=%)"; \
1054 a38bfce5 Iustin Pop
	for file in $$RELSRCS; do \
1055 a38bfce5 Iustin Pop
		hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1056 22c5390d Iustin Pop
		$(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1057 a38bfce5 Iustin Pop
	done ; \
1058 22c5390d Iustin Pop
	$(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1059 a38bfce5 Iustin Pop
		-t ganeti-htools -p haddock-prologue \
1060 a38bfce5 Iustin Pop
		--source-module="%{MODULE/.//}.html" \
1061 a38bfce5 Iustin Pop
		--source-entity="%{MODULE/.//}.html#%{NAME}" \
1062 c478f837 Iustin Pop
		$$OPTGHC \
1063 c3f67183 Iustin Pop
		$(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1064 d128fdb6 Iustin Pop
1065 13e720f1 Iustin Pop
.PHONY: TAGS
1066 eb732fb5 Michael Hanselmann
TAGS: $(BUILT_SOURCES)
1067 13e720f1 Iustin Pop
	rm -f TAGS
1068 74fa8200 Iustin Pop
	find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1069 74fa8200 Iustin Pop
	  -path './daemons/ganeti-*' -o -path './tools/*' -o \
1070 74fa8200 Iustin Pop
	  -path './qa/*.py' | \
1071 3bb5c580 Iustin Pop
	  etags -l python -
1072 13e720f1 Iustin Pop
1073 27e336af Michael Hanselmann
.PHONY: coverage
1074 b91e9518 Iustin Pop
if WANT_HTOOLS
1075 b91e9518 Iustin Pop
coverage: py-coverage hs-coverage
1076 b91e9518 Iustin Pop
else
1077 b91e9518 Iustin Pop
coverage: py-coverage
1078 b91e9518 Iustin Pop
endif
1079 b91e9518 Iustin Pop
1080 b91e9518 Iustin Pop
.PHONY: py-coverage
1081 b91e9518 Iustin Pop
py-coverage: $(BUILT_SOURCES) $(python_tests)
1082 27e336af Michael Hanselmann
	set -e; \
1083 22c5390d Iustin Pop
	COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1084 22c5390d Iustin Pop
	TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1085 22c5390d Iustin Pop
	HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1086 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1087 e8c8cf1a Michael Hanselmann
	$(python_tests)
1088 27e336af Michael Hanselmann
1089 b91e9518 Iustin Pop
.PHONY: hs-coverage
1090 b91e9518 Iustin Pop
hs-coverage: $(haskell_tests)
1091 b91e9518 Iustin Pop
	cd htools && rm -f *.tix *.mix && ./test
1092 22c5390d Iustin Pop
	mkdir -p $(COVERAGE_HS_DIR)
1093 22c5390d Iustin Pop
	hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1094 b91e9518 Iustin Pop
	hpc report htools/test $(HPCEXCL)
1095 b91e9518 Iustin Pop
1096 ec8379bd Iustin Pop
# Special "kind-of-QA" target for htools, needs special setup (all
1097 ec8379bd Iustin Pop
# tools compiled with -fhpc)
1098 ec8379bd Iustin Pop
.PHONY: live-test
1099 ec8379bd Iustin Pop
live-test: all
1100 ec8379bd Iustin Pop
	set -e ; \
1101 ec8379bd Iustin Pop
	cd htools; \
1102 ec8379bd Iustin Pop
	rm -f .hpc; ln -s ../.hpc .hpc; \
1103 ec8379bd Iustin Pop
	rm -f *.tix *.mix; \
1104 ec8379bd Iustin Pop
	./live-test.sh; \
1105 c3f67183 Iustin Pop
	hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1106 ec8379bd Iustin Pop
	  --output=live-test.tix ; \
1107 22c5390d Iustin Pop
	@mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1108 22c5390d Iustin Pop
	hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1109 ec8379bd Iustin Pop
		--srcdir=.. $(HPCEXCL) ; \
1110 ec8379bd Iustin Pop
	hpc report --srcdir=.. live-test $(HPCEXCL)
1111 b91e9518 Iustin Pop
1112 b341b9ca Guido Trotter
commit-check: distcheck lint apidoc
1113 b341b9ca Guido Trotter
1114 3baa809c Michael Hanselmann
-include ./Makefile.local
1115 3baa809c Michael Hanselmann
1116 e8230860 Michael Hanselmann
# vim: set noet :